namespace FileTransferState{

	class CFTStateSendBase : public CFTState
	{
	public:
		CFTStateSendBase(UIChatFileElement * pUIElem);
	protected:
		virtual void _InitControlValue();
		virtual void _SetControlPos(const CPoint& ptPos, CSize& sz, DWORD dwFlags);
		virtual void _CalcFileNameSize(const CPoint& ptOffset);
		virtual void _CalcFileIconSize(const CPoint& ptOffset);
		virtual Image* _GetBubbleImage( BOOL bMine, int nIndex );
	};

	class CStateSendInit : public CFTStateSendBase
	{
	public:
		CStateSendInit(UIChatFileElement * pUIElem);
		~CStateSendInit(void);
		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual void _OnButtonClick();
		BOOL _DrawProgressBar(Graphics *pGraph, RectF& rcBar);
		virtual BOOL _DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset );
	protected:
		static const int m_nProgressbarLeftEdge = 14;
		static const int m_nProgressbarRightEdge = 34;
		static const int m_nButtonRightEdge = 19;
	};

	class CStateSendProgress : public CFTStateSendBase
	{
	public:
		CStateSendProgress(UIChatFileElement * pUIElem);
		~CStateSendProgress(void);

		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual void _OnButtonClick();
		virtual BOOL _DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset );
		virtual BOOL _DrawProgressBar(Graphics *pGraph, RectF& rcBar);
	protected:
		static const int m_nProgressbarLeftEdge = 14;
		static const int m_nProgressbarRightEdge = 34;
		static const int m_nButtonRightEdge = 19;
	};

	class CStateSendComplete : public CFTStateSendBase
	{
	public:
		CStateSendComplete(UIChatFileElement *pUIElem);
		~CStateSendComplete();
		virtual void _CalcProgressSize( const CPoint& ptOffset );
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
	};

	class CStateSendCancel : public CFTStateSendBase
	{
	public:
		CStateSendCancel(UIChatFileElement *pUIElem);
		~CStateSendCancel();
		virtual void _CalcProgressSize( const CPoint& ptOffset );
		void _CalcButtonsSize( const CPoint& ptOffset );
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
	};

	class CStateSendError : public CFTStateSendBase
	{
	public:
		CStateSendError(UIChatFileElement *pUIElem);
		~CStateSendError();
		virtual void _CalcButtonsSize( const CPoint& ptOffset );
		virtual void _CalcProgressSize( const CPoint& ptOffset );
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
	};
}